Django model,QuerySet 序列化成json报错

运行django的views.py中的代码报错如下:
'MetaDict' object has no attribute 'concrete_model'
出错的代码行是:hall_list_data = serializers.serialize("json", clientcase.objects.filter(category="hall"))

我的models.py中定义的模型如下:

- coding: utf-8 -

from django.db import models
from mongoengine import *
from acto_website.settings import DBNAME
import json
import pymongo

connect(DBNAME)

Create your models here.

#客户案例模型
class clientcase(Document):
category = StringField(max_length = 1000)
name = StringField(max_length= 1000)
address = StringField(max_length = 1000)
introduction = StringField(max_length = 100000)
store_time = IntField()
pictures = ListField(DictField())
videos = ListField(DictField())

def __str__(self):
    return self.name

我用的model是基于mongoengine的,没有用它自己的
哪位大侠指点一下,十分感谢

Csdn user default icon
上传中...
上传图片
插入图片
抄袭、复制答案,以达到刷声望分或其他目的的行为,在CSDN问答是严格禁止的,一经发现立刻封号。是时候展现真正的技术了!
其他相关推荐
使用MongoEngine Pymongo使用Django不能返回的JSON对象?

所以我试图返回一个JSON对象的一个项目。我已经花了几个小时试图让Django的只是返回的JSON。 继承人,我们一直在努力的观点:def json(request, first_name): user = User.objects.all() #user = User.objects.all().values() result = simplejson.dumps(user, default=json_util.default) return HttpResponse(result) 这里是我的模型:class User(Document): gender = StringField( choices=['male', 'female', 'Unknown']) age = IntField() email = EmailField() display_name = StringField(max_length=50) first_name = StringField(max_length=50) last_name = StringField(max_length=50) location = StringField(max_length=50) status = StringField(max_length=50) hideStatus = BooleanField() photos = ListField(EmbeddedDocumentField('Photo')) profile =ListField(EmbeddedDocumentField('ProfileItem')) allProfile = ListField(EmbeddedDocumentField('ProfileItem')) #only return for your own profile 这就是它的返回:[<User: User object>, <User: User object>] is not JSON serializable 哪位大侠指教一下如何根据django获取的mongoendgine中的mongo对象转化为json格式 十分感谢

django +jquery+ ajax get提交报错,post提交就可以

``` 模板:(index.html) “ <html> <body> <p>请输入两个数字</p> <form action="/index" method="get"> a: <input type="text" id="a" name="a"> <br> b: <input type="text" id="b" name="b"> <br> <p>result: <span id='result'></span></p> <button type="button" id='sum'>提交</button> </form> <!---<script type="text/javascript" src="/static/jquery-3.3.1.min.js"></script>---> <script src="http://apps.bdimg.com/libs/jquery/1.11.1/jquery.min.js"></script> <script> $(document).ready(function(){ $("#sum").click(function(){ var a = $("#a").val(); var b = $("#b").val(); $.get("/index",{'a':a,'b':b}, function(ret){ $('#result').html(ret.result) }) }); }); </script> </body> </html>” ``` ``` **url 代码:** urlpatterns = [ url(r'testDb' , testDb), url(r'query' , Query), url(r'formdemo' , searchtest.search), url(r'^seachDemo' , searchtest.search_form), url(r'^index' , view.loginIndex), ] ``` ``` python 代码view.py: def loginIndex(request): if(request.method == 'GET'): a = int(request.GET.get('a')) b = int(request.GET.get('b')) return_json = {'result': a + b} return HttpResponse(json.dumps(return_json), content_type='application/json') return render(request,"index.html") ``` 报错: TypeError at /index int() argument must be a string, a bytes-like object or a number, not 'NoneType' Request Method: GET Request URL: http://127.0.0.1:8000/index Django Version: 2.0.3 Exception Type: TypeError Exception Value: int() argument must be a string, a bytes-like object or a number, not 'NoneType' Exception Location: D:\PythonDemo\PythonDemo\view.py in loginIndex, line 12 Python Executable: D:\PythonDemo\venv\Scripts\python.exe Python Version: 3.6.3 Python Path: ['D:\\PythonDemo', 'D:\\PythonDemo', 'D:\\PythonDemo\\venv\\Scripts\\python36.zip', 'X:\\python\\DLLs', 'X:\\python\\lib', 'X:\\python', 'D:\\PythonDemo\\venv', 'D:\\PythonDemo\\venv\\lib\\site-packages', 'D:\\PythonDemo\\venv\\lib\\site-packages\\setuptools-28.8.0-py3.6.egg', 'D:\\PythonDemo\\venv\\lib\\site-packages\\pip-9.0.1-py3.6.egg', 'X:\\PyCharm\\PyCharm 2017.3.4\\helpers\\pycharm_matplotlib_backend'] Server time: Sun, 18 Mar 2018 07:35:40 +0000 这个报错也让我很懵逼,我把提交方式,和ajax方法改成post,就没有这个报错,程序可以正常运行

django 提交表单后 函数解析参数报错TypeError: not nonetype

这是views里的代码 ``` from django.http import HttpResponse from django.shortcuts import render from .models import Item # Create your views here. def get_html(req): return render(req,"item.html") def create_item(req): #解析参数 params = req.POST name = params.get("i_name") barcode = params.get("i_barcode") cate_id = int(params.get("cate_id")) #创建数据 item = Item.objects.create( name = name, barcode = barcode, category_id=cate_id ) return HttpResponse("创建成功啦{}".format(item.name)) ``` 这是models的代码 ``` from django.db import models # Create your models here. class Category(models.Model): name = models.CharField( max_length=30, verbose_name="分类名", db_column="cate_name" #改数据表字段的名字 ) cate_num = models.CharField( max_length=20, null=True, verbose_name="分类的编号" ) create_time = models.DateTimeField( auto_now_add=True, verbose_name="创建时间" ) update_time = models.DateTimeField( auto_now=True, verbose_name="修改时间" ) class Meta: # 改数据表的名字 db_table = "category" # PEP8 class Item(models.Model): name = models.CharField( max_length=40, verbose_name="商品名字" ) barcode = models.CharField( max_length=13, verbose_name="条码", null=True ) category = models.ForeignKey( Category, db_index=True ) ``` ![图片说明](https://img-ask.csdn.net/upload/201903/05/1551792138_370806.png)![图片说明](https://img-ask.csdn.net/upload/201903/05/1551792151_50008.png)

django2.13+xadmin 后台删除数据报错问题

我的django是 2.13版本的 xadmin是从github新下载的版本。 我在后台管理界面 删除一条数据后 报错,提示: get_deleted_objects() takes 3 positional arguments but 5 were given Location:\xadmin\plugins\actions.py in do_action, line 94 网上的办法适用于django2.0版本 请大神帮忙解决下

Django migrate的时候报错

migration可以,但执行migrate的时候就报错 models.py ``` class Category(models.Model): name = models.CharField('名称', max_length=16) class Tag(models.Model): name = models.CharField('名称', max_length=16) class Article(models.Model): title = models.CharField(max_length=32, default='Title') content = models.TextField(null=True) pub_time = models.DateTimeField(auto_now_add=True) author = models.CharField(max_length=16, default='Author') category = models.ForeignKey(Category, verbose_name='分类', default='Category') tags = models.ManyToManyField(Tag, verbose_name='标签') def __unicode__(self): return self.title class Comment(models.Model): blog = models.ForeignKey(Article, verbose_name='博客') name = models.CharField('称呼', max_length=16) email = models.EmailField('邮箱') content = models.CharField('内容', max_length=140) created = models.DateTimeField('发布时间', auto_now_add=True) ``` 下面是报错信息![图片说明](https://img-ask.csdn.net/upload/201804/07/1523113359_702807.png) 感觉可能是版本问题但是又不知道是哪的错,把Category的语句注释了也不行,求大神帮忙解答,感谢!

Django执行python manage.py migrate报错情况如下,求大神指教

![图片说明](https://img-ask.csdn.net/upload/201905/11/1557577343_698571.png) 老是报错,求大神指点

Pycharm创建Django项目时配置虚拟环境报错

![首先使用代码创建django项目](https://img-ask.csdn.net/upload/201905/17/1558093614_505782.png) ![配置虚拟环境](https://img-ask.csdn.net/upload/201905/17/1558093695_325078.png)![出现以上错误](https://img-ask.csdn.net/upload/201905/17/1558093703_228820.png) anconda 是最新的 19.03版本 Python 3.7.3 pycharm 是专业版 19.02版本 Django 2.0.7 如图,问这个怎么办? 出现这个问题是因为我原来的Django在虚拟环境运行时候找不到指定模块,所以重装了。但是重装之后出现这个问题,求大神解决!

Django2.0.4连接sqlser2012数据库报错

报错信息: --- File "E:\PythonProject\WenSnap\venv\lib\site-packages\sql_server\pyodbc\base.py", line 307, in get_new_connection timeout=timeout) --- django.db.utils.InterfaceError: ('28000', "[28000] [Microsoft][ODBC Driver 13 for SQL Server][SQL Server]Login failed for user 'srsa'. (18456) (SQLDriverConnect); [28000] [Microsoft][ODBC Driver 13 for SQL Server]Invalid connection string attribute (0); [28000] [Microsoft][ODBC Driver 13 for SQL Server][SQL Server]**Login failed for user 'srsa'.** (18456); [28000] [Microsoft][ODBC Driver 13 for SQL Server]Invalid connection string attribute (0)") 我的django是2.0.4,windows操作系统 sqlser2012 按照网上所说的我已经安装了相应的包: ![图片说明](https://img-ask.csdn.net/upload/201903/05/1551770846_770974.png) setting.py中DATABASE的配置如下 ![图片说明](https://img-ask.csdn.net/upload/201903/05/1551770998_759455.png) --- 其中'driver': 'SQL Server Native Client 11.0' 和 'driver': 'ODBC Driver 13 for SQL Server' 报错一样,如最上边的报错 ---- 'driver': 'ODBC Driver 17 for SQL Server'的报错是: django.db.utils.OperationalError: ('08001', '[08001] [Microsoft][ODBC Driver 17 for SQL Server]客户端不支持加密。 (21) (SQLDriverConnect); [08001] [Microsoft][ODBC Driver 17 for SQL Server]SQL Server 网络接口: 参数错误。\r\n (87); [08001] [Microsoft][ODBC Driver 17 for SQL Server]客户端无法建立连接 (21); [08001] [Microsoft][ODBC Driver 17 for SQL Server]无效的连接字符串属性 (0); [08001] [Microsoft][ODBC Driver 17 for SQL Server]与 SQL Server 建立连接时发生了与网络相关的或特定于实例的错误。找不到或无法访问服务器。请检查实例名称是否正确以及 SQL Server 是否配置为允许远程连接。有关详细信息,请参阅 SQL Server 联机丛书。 (87)') 请各位大神帮忙看看

python3的Django中的表单上传图片报错

python的django3的表单上传图片报错: **dictionary update sequence element #0 has length 1; 2 is required** 表单如下: ![图片说明](https://img-ask.csdn.net/upload/201901/18/1547754622_629551.png) view中的uploadHandle视图: **def uploadHandle(request): return HttpResponse('hello')** 点击上传之后就报如上所述的错误。请教各位大佬这是什么原因造成的? 望各位大佬不吝赐教。 小白先在此跪谢了!!! 补充说明:python版本3.71,django版本2.15

django 迁移数据库 报错,求大神指教!

不知道为什么,创建一个新的app,迁移数据库就报错了,报错信息如下,求大神帮帮忙 ![图片说明](https://img-ask.csdn.net/upload/201911/22/1574414856_903196.png)

使用JSON将Django日期时间传递到Golang服务器

<div class="post-text" itemprop="text"> <blockquote> <p>Here is my django model</p> </blockquote> <pre class="lang-py prettyprint-override"><code>class Data(models.Model): created = models.DateTimeField(null=True, blank=True, editable=False) modified = models.DateTimeField(null=True, blank=True) raw = models.TextField(null=True, blank=True) uuid = models.CharField(blank=True, null=True, max_length=48,unique=True) used = models.BooleanField(default=False,null=True) name = models.CharField(blank=True, null=True, max_length=200) geohash = models.CharField(blank=True, null=True, max_length=200) def __str__(self): return str(self.created) + ":" + str(self.raw) def __unicode__(self): return str(self.created) + ":" + str(self.raw) def save(self, *args, **kwargs): """ On save, update timestamps """ if not self.uuid : self.uuid = str(uuid.uuid4().hex) +str(random.randint(1000,9999) ) if not self.id: self.created = timezone.now() self.modified = timezone.now() # if not self.geoHash and (self.gpsLat and self.gpsLong): # Geohash.encode(self.gpsLat, self.gpsLong) return super(DataLbc, self).save(*args, **kwargs) def toJson(self): ret = {} ret["Created"] = str(self.created) ret["Modified"] = str(self.modified) ret["Used"] = self.used ret["Raw"] = self.raw return ret </code></pre> <blockquote> <p>Here is the way that i send it to my golang server :</p> </blockquote> <pre class="lang-py prettyprint-override"><code>from RawOffer.models import Data while True: try : for data in Data.objects.all()[:10]: requests.post("http://127.0.0.1:8087/convert/",json=data.toJson()) except Exception as e: print(e) time.sleep(5) </code></pre> <blockquote> <p>Now my golang server : </p> </blockquote> <pre class="lang-golang prettyprint-override"><code>package main import ( "database/sql" "encoding/json" "fmt" "github.com/gin-contrib/cors" "github.com/gin-gonic/gin" "github.com/jmoiron/sqlx" "github.com/lib/pq" "strings" "gopkg.in/guregu/null.v3" ) type RawOffer struct { RawOfferData string `json:"Raw"` Modified null.Time `json:"Modified"` Created null.Time `json:"Created"` } func convertLbc(c *gin.Context) { var rawOffer RawOffer c.BindJSON(&amp;rawOffer) fmt.Println(rawOffer.Created) var err error s := strings.Split(rawOffer.RawOfferData, `"ads": `) s2 := `{ "ads": ` + s[1] result := strings.Replace(s2, `, "status": "ready"}]`, ``, -1) //fmt.Println(result) var rawOfferLbc RawOfferLbc if err = json.Unmarshal([]byte(result), &amp;rawOfferLbc); err != nil { fmt.Println(result) panic(err) } } var db *sqlx.DB func main() { var err error fmt.Println("begin") r := gin.Default() r.Use(cors.Default()) r.POST("/convert/",convert) r.Run((":8087")) } </code></pre> <p>but for Created and modified when i try to receive it i have <code>{0001-01-01 00:00:00 +0000 UTC false}</code></p> <p>How to serialize a django datetime to send it in json and how to get it in golang?</p> <p>My main goal so is to send an object with the date from the django app to a microservice in golang. So I need to serialize the django date and I need to write a lot of text because stackoverflow won't let me post my program if i don't write enough text ...</p> <p>Regards</p> </div>

Django执行python manage.py makemigrations 报错,数据库是postgresql,大神救救孩子

Traceback (most recent call last): File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\base\base.py", line 220, in ensure_connection self.connect() File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\utils\asyncio.py", line 26, in inner return func(*args, **kwargs) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\base\base.py", line 197, in connect self.connection = self.get_new_connection(conn_params) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\utils\asyncio.py", line 26, in inner return func(*args, **kwargs) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\postgresql\base.py", line 185, in get_new_connection connection = Database.connect(**conn_params) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\psycopg2\__init__.py", line 126, in connect conn = _connect(dsn, connection_factory=connection_factory, **kwasync) psycopg2.OperationalError The above exception was the direct cause of the following exception: Traceback (most recent call last): File "manage.py", line 21, in <module> main() File "manage.py", line 17, in main execute_from_command_line(sys.argv) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\core\management\__init__.py", line 401, in execute_from_command_line utility.execute() File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\core\management\__init__.py", line 395, in execute self.fetch_command(subcommand).run_from_argv(self.argv) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\core\management\base.py", line 328, in run_from_argv self.execute(*args, **cmd_options) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\core\management\base.py", line 369, in execute output = self.handle(*args, **options) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\core\management\base.py", line 83, in wrapped res = handle_func(*args, **kwargs) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\core\management\commands\makemigrations.py", line 101, in handle loader.check_consistent_history(connection) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\migrations\loader.py", line 283, in check_consistent_history applied = recorder.applied_migrations() File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\migrations\recorder.py", line 76, in applied_migrations if self.has_table(): File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\migrations\recorder.py", line 56, in has_table return self.Migration._meta.db_table in self.connection.introspection.table_names(self.connection.cursor()) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\utils\asyncio.py", line 26, in inner return func(*args, **kwargs) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\base\base.py", line 260, in cursor return self._cursor() File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\base\base.py", line 236, in _cursor self.ensure_connection() File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\utils\asyncio.py", line 26, in inner return func(*args, **kwargs) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\base\base.py", line 220, in ensure_connection self.connect() File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\utils.py", line 90, in __exit__ raise dj_exc_value.with_traceback(traceback) from exc_value File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\base\base.py", line 220, in ensure_connection self.connect() File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\utils\asyncio.py", line 26, in inner return func(*args, **kwargs) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\base\base.py", line 197, in connect self.connection = self.get_new_connection(conn_params) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\utils\asyncio.py", line 26, in inner return func(*args, **kwargs) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\django\db\backends\postgresql\base.py", line 185, in get_new_connection connection = Database.connect(**conn_params) File "D:\Program Files (x86)\Microsoft Visual Studio\Shared\Python37_64\lib\site-packages\psycopg2\__init__.py", line 126, in connect conn = _connect(dsn, connection_factory=connection_factory, **kwasync) django.db.utils.OperationalError

django的model不能创建对应表

我的python的版本是3.4 django的版本是1.7.2 这个是我的models.py文件 from django.db import models class Test(models.Model): name = models.CharField(max_length=100) def __unicode__(self): return self.name 但是python manage.py syncdb同步数据库之后 没有出现blog_test表 只有这些 ![](http://img.bbs.csdn.net/upload/201501/13/1421154027_527365.png) 这是怎么回事啊?

django makemigrations报错

File "E:\python\shop\apps\trade\models.py", line 7, in <module> User = get_user_model() File "C:\Python36-32\lib\site-packages\django-1.10.6-py3.6.egg\django\contrib\auth\__init__.py", line 163, in get_user_model return django_apps.get_model(settings.AUTH_USER_MODEL) File "C:\Python36-32\lib\site-packages\django-1.10.6-py3.6.egg\django\apps\registry.py", line 192, in get_model self.check_models_ready() File "C:\Python36-32\lib\site-packages\django-1.10.6-py3.6.egg\django\apps\registry.py", line 131, in check_models_ready raise AppRegistryNotReady("Models aren't loaded yet.") django.core.exceptions.AppRegistryNotReady: Models aren't loaded yet.

python django 返回 return json遇到的问题

我用django模型查询了一条数据返回为json格式 android端解析遇到了一些问题 以下是服务器返回的json格式 用List<object>才能解析 { "obj":[ { "failureDate":1459782820, "token":"iosjdsjfijioeru", "userId":123213213, "account":"8882389482394", "key":"iosndfiu34248", "id":8 } ], "code":200 } 以下为理想的json格式 直接用object解析 { "obj":{ "failureDate":1459782820, "token":"iosjdsjfijioeru", "userId":123213213, "account":"8882389482394", "key":"iosndfiu34248", "id":8 }, "code":200 } 如果我想返回一个对象第一个json是不可以的 至于第二个我还不知道怎么将django模型对象 转换成第二种json格式 花括号保存对象 方括号保存数组 请问 python django怎么才能生成没有方括号的json

django实现**.zip包下载报错内存使用过大

django实现**.zip包下载报错内存使用过大 各位朋友们好: 我使用django的功能想实现下载一个大的**.zip包的功能,该包大小差不多1个G 网上查了一些方法:本来是准备用遍历文件目录逐个文件打包的,但是我需要打包的文件很多,用这个方法很慢,而且由于我里面有中文文件,遍历文件路径还会报错。因此我选择了,直接我先把所有文件打包到名叫test.zip中,希望用django实现直接下载test.zip包的功能,但是尝试了好几次,都报错:而且保存的原因提示是内存使用过大这种,我看了网上的大文件下载,用的就是下面这个方法: ``` 19.def send_zipfile(request): 20. """ 21. Create a ZIP file on disk and transmit it in chunks of 8KB, 22. without loading the whole file into memory. A similar approach can 23. be used for large dynamic PDF files. 24. """ 25. temp = tempfile.TemporaryFile() 26. archive = zipfile.ZipFile(temp, 'w', zipfile.ZIP_DEFLATED) 28. filename = “test.zip” # Select your files here. 29. archive.write(filename) 30. archive.close() 31. wrapper = FileWrapper(temp) 32. response = HttpResponse(wrapper, content_type='application/zip') 33. response['Content-Disposition'] = 'attachment; filename=test.zip' 34. response['Content-Length'] = temp.tell() 35. temp.seek(0) 36. return response ``` 希望朋友们能指点一下我这段代码哪里不对,或者有相关直接用django下载zip包的代码也麻烦告知一下。 万分感谢了。

python3 django models 调用出错

![图片说明](https://img-ask.csdn.net/upload/201708/08/1502160029_39827.png)![![图片说明](https://img-ask.csdn.net/upload/201708/08/1502159234_483138.png)图片说明](https://img-ask.csdn.net/upload/201708/08/1502159219_209781.png)[参考连接](http://www.runoob.com/django/django-model.html "demo") # models.py from django.db import models class Test(models.Model): name = models.CharField(max_length=20) #testdb.py from django.http import HttpResponse from TestModel.models import Test # 数据库操作 def testdb(request): test1 = Test(name='runoob') test1.save() return HttpResponse("<p>数据添加成功!</p>") 报错:ModuleNotFoundError: No module named 'Test'

pycharm创建Django,出现如下报错,求解

AttributeError: module 'pip' has no attribute 'main'

django自定义用户模型使用的uid做主键,但是migrate报错默认id字段无效,django版本3.0.3

用户模型代码 ``` class UserModel(AbstractUser): first_name = None last_name = None gender = ( ('male', '男'), ('female', '女'), ('privacy', '不愿告知') ) uid = ShortUUIDField(primary_key=True) phone = models.CharField(verbose_name='手机号', max_length=11, blank=True) sex = models.CharField(verbose_name='性别', choices=gender, default='男', max_length=32) avatar = models.ImageField(verbose_name='头像', upload_to='avatar/', blank=True) class Meta: verbose_name = '用户' verbose_name_plural = verbose_name def __str__(self): return self.username ``` 报错代码 ``` django.db.utils.InternalError: (1067, "Invalid default value for 'user_post_id'") ```

大学四年自学走来,这些私藏的实用工具/学习网站我贡献出来了

大学四年,看课本是不可能一直看课本的了,对于学习,特别是自学,善于搜索网上的一些资源来辅助,还是非常有必要的,下面我就把这几年私藏的各种资源,网站贡献出来给你们。主要有:电子书搜索、实用工具、在线视频学习网站、非视频学习网站、软件下载、面试/求职必备网站。 注意:文中提到的所有资源,文末我都给你整理好了,你们只管拿去,如果觉得不错,转发、分享就是最大的支持了。 一、电子书搜索 对于大部分程序员...

在中国程序员是青春饭吗?

今年,我也32了 ,为了不给大家误导,咨询了猎头、圈内好友,以及年过35岁的几位老程序员……舍了老脸去揭人家伤疤……希望能给大家以帮助,记得帮我点赞哦。 目录: 你以为的人生 一次又一次的伤害 猎头界的真相 如何应对互联网行业的「中年危机」 一、你以为的人生 刚入行时,拿着傲人的工资,想着好好干,以为我们的人生是这样的: 等真到了那一天,你会发现,你的人生很可能是这样的: ...

Java基础知识面试题(2020最新版)

文章目录Java概述何为编程什么是Javajdk1.5之后的三大版本JVM、JRE和JDK的关系什么是跨平台性?原理是什么Java语言有哪些特点什么是字节码?采用字节码的最大好处是什么什么是Java程序的主类?应用程序和小程序的主类有何不同?Java应用程序与小程序之间有那些差别?Java和C++的区别Oracle JDK 和 OpenJDK 的对比基础语法数据类型Java有哪些数据类型switc...

我以为我学懂了数据结构,直到看了这个导图才发现,我错了

数据结构与算法思维导图

String s = new String(" a ") 到底产生几个对象?

老生常谈的一个梗,到2020了还在争论,你们一天天的,哎哎哎,我不是针对你一个,我是说在座的各位都是人才! 上图红色的这3个箭头,对于通过new产生一个字符串(”宜春”)时,会先去常量池中查找是否已经有了”宜春”对象,如果没有则在常量池中创建一个此字符串对象,然后堆中再创建一个常量池中此”宜春”对象的拷贝对象。 也就是说准确答案是产生了一个或两个对象,如果常量池中原来没有 ”宜春” ,就是两个。...

技术大佬:我去,你写的 switch 语句也太老土了吧

昨天早上通过远程的方式 review 了两名新来同事的代码,大部分代码都写得很漂亮,严谨的同时注释也很到位,这令我非常满意。但当我看到他们当中有一个人写的 switch 语句时,还是忍不住破口大骂:“我擦,小王,你丫写的 switch 语句也太老土了吧!” 来看看小王写的代码吧,看完不要骂我装逼啊。 private static String createPlayer(PlayerTypes p...

Linux面试题(2020最新版)

文章目录Linux 概述什么是LinuxUnix和Linux有什么区别?什么是 Linux 内核?Linux的基本组件是什么?Linux 的体系结构BASH和DOS之间的基本区别是什么?Linux 开机启动过程?Linux系统缺省的运行级别?Linux 使用的进程间通信方式?Linux 有哪些系统日志文件?Linux系统安装多个桌面环境有帮助吗?什么是交换空间?什么是root帐户什么是LILO?什...

Linux命令学习神器!命令看不懂直接给你解释!

大家都知道,Linux 系统有非常多的命令,而且每个命令又有非常多的用法,想要全部记住所有命令的所有用法,恐怕是一件不可能完成的任务。 一般情况下,我们学习一个命令时,要么直接百度去搜索它的用法,要么就直接用 man 命令去查看守冗长的帮助手册。这两个都可以实现我们的目标,但有没有更简便的方式呢? 答案是必须有的!今天给大家推荐一款有趣而实用学习神器 — kmdr,让你解锁 Linux 学习新姿势...

和黑客斗争的 6 天!

互联网公司工作,很难避免不和黑客们打交道,我呆过的两家互联网公司,几乎每月每天每分钟都有黑客在公司网站上扫描。有的是寻找 Sql 注入的缺口,有的是寻找线上服务器可能存在的漏洞,大部分都...

史上最全的 python 基础知识汇总篇,没有比这再全面的了,建议收藏

网友们有福了,小编终于把基础篇的内容全部涉略了一遍,这是一篇关于基础知识的汇总的文章,请朋友们收下,不用客气,不过文章篇幅肯能会有点长,耐心阅读吧爬虫(七十)多进程multiproces...

讲一个程序员如何副业月赚三万的真实故事

loonggg读完需要3分钟速读仅需 1 分钟大家好,我是你们的校长。我之前讲过,这年头,只要肯动脑,肯行动,程序员凭借自己的技术,赚钱的方式还是有很多种的。仅仅靠在公司出卖自己的劳动时...

女程序员,为什么比男程序员少???

昨天看到一档综艺节目,讨论了两个话题:(1)中国学生的数学成绩,平均下来看,会比国外好?为什么?(2)男生的数学成绩,平均下来看,会比女生好?为什么?同时,我又联想到了一个技术圈经常讨...

85后蒋凡:28岁实现财务自由、34岁成为阿里万亿电商帝国双掌门,他的人生底层逻辑是什么?...

蒋凡是何许人也? 2017年12月27日,在入职4年时间里,蒋凡开挂般坐上了淘宝总裁位置。 为此,时任阿里CEO张勇在任命书中力赞: 蒋凡加入阿里,始终保持创业者的冲劲,有敏锐的...

总结了 150 余个神奇网站,你不来瞅瞅吗?

原博客再更新,可能就没了,之后将持续更新本篇博客。

副业收入是我做程序媛的3倍,工作外的B面人生是怎样的?

提到“程序员”,多数人脑海里首先想到的大约是:为人木讷、薪水超高、工作枯燥…… 然而,当离开工作岗位,撕去层层标签,脱下“程序员”这身外套,有的人生动又有趣,马上展现出了完全不同的A/B面人生! 不论是简单的爱好,还是正经的副业,他们都干得同样出色。偶尔,还能和程序员的特质结合,产生奇妙的“化学反应”。 @Charlotte:平日素颜示人,周末美妆博主 大家都以为程序媛也个个不修边幅,但我们也许...

MySQL数据库面试题(2020最新版)

文章目录数据库基础知识为什么要使用数据库什么是SQL?什么是MySQL?数据库三大范式是什么mysql有关权限的表都有哪几个MySQL的binlog有有几种录入格式?分别有什么区别?数据类型mysql有哪些数据类型引擎MySQL存储引擎MyISAM与InnoDB区别MyISAM索引与InnoDB索引的区别?InnoDB引擎的4大特性存储引擎选择索引什么是索引?索引有哪些优缺点?索引使用场景(重点)...

新一代神器STM32CubeMonitor介绍、下载、安装和使用教程

关注、星标公众号,不错过精彩内容作者:黄工公众号:strongerHuang最近ST官网悄悄新上线了一款比较强大的工具:STM32CubeMonitor V1.0.0。经过我研究和使用之...

如果你是老板,你会不会踢了这样的员工?

有个好朋友ZS,是技术总监,昨天问我:“有一个老下属,跟了我很多年,做事勤勤恳恳,主动性也很好。但随着公司的发展,他的进步速度,跟不上团队的步伐了,有点...

我入职阿里后,才知道原来简历这么写

私下里,有不少读者问我:“二哥,如何才能写出一份专业的技术简历呢?我总感觉自己写的简历太烂了,所以投了无数份,都石沉大海了。”说实话,我自己好多年没有写过简历了,但我认识的一个同行,他在阿里,给我说了一些他当年写简历的方法论,我感觉太牛逼了,实在是忍不住,就分享了出来,希望能够帮助到你。 01、简历的本质 作为简历的撰写者,你必须要搞清楚一点,简历的本质是什么,它就是为了来销售你的价值主张的。往深...

大学一路走来,学习互联网全靠这几个网站,最终拿下了一把offer

大佬原来都是这样炼成的

离职半年了,老东家又发 offer,回不回?

有小伙伴问松哥这个问题,他在上海某公司,在离职了几个月后,前公司的领导联系到他,希望他能够返聘回去,他很纠结要不要回去? 俗话说好马不吃回头草,但是这个小伙伴既然感到纠结了,我觉得至少说明了两个问题:1.曾经的公司还不错;2.现在的日子也不是很如意。否则应该就不会纠结了。 老实说,松哥之前也有过类似的经历,今天就来和小伙伴们聊聊回头草到底吃不吃。 首先一个基本观点,就是离职了也没必要和老东家弄的苦...

为什么你不想学习?只想玩?人是如何一步一步废掉的

不知道是不是只有我这样子,还是你们也有过类似的经历。 上学的时候总有很多光辉历史,学年名列前茅,或者单科目大佬,但是虽然慢慢地长大了,你开始懈怠了,开始废掉了。。。 什么?你说不知道具体的情况是怎么样的? 我来告诉你: 你常常潜意识里或者心理觉得,自己真正的生活或者奋斗还没有开始。总是幻想着自己还拥有大把时间,还有无限的可能,自己还能逆风翻盘,只不是自己还没开始罢了,自己以后肯定会变得特别厉害...

什么时候跳槽,为什么离职,你想好了么?

都是出来打工的,多为自己着想

为什么程序员做外包会被瞧不起?

二哥,有个事想询问下您的意见,您觉得应届生值得去外包吗?公司虽然挺大的,中xx,但待遇感觉挺低,马上要报到,挺纠结的。

当HR压你价,说你只值7K,你该怎么回答?

当HR压你价,说你只值7K时,你可以流畅地回答,记住,是流畅,不能犹豫。 礼貌地说:“7K是吗?了解了。嗯~其实我对贵司的面试官印象很好。只不过,现在我的手头上已经有一份11K的offer。来面试,主要也是自己对贵司挺有兴趣的,所以过来看看……”(未完) 这段话主要是陪HR互诈的同时,从公司兴趣,公司职员印象上,都给予对方正面的肯定,既能提升HR的好感度,又能让谈判气氛融洽,为后面的发挥留足空间。...

面试阿里p7,被按在地上摩擦,鬼知道我经历了什么?

面试阿里p7被问到的问题(当时我只知道第一个):@Conditional是做什么的?@Conditional多个条件是什么逻辑关系?条件判断在什么时候执...

你期望月薪4万,出门右拐,不送,这几个点,你也就是个初级的水平

先来看几个问题通过注解的方式注入依赖对象,介绍一下你知道的几种方式@Autowired和@Resource有何区别说一下@Autowired查找候选者的...

面试了一个 31 岁程序员,让我有所触动,30岁以上的程序员该何去何从?

最近面试了一个31岁8年经验的程序猿,让我有点感慨,大龄程序猿该何去何从。

大三实习生,字节跳动面经分享,已拿Offer

说实话,自己的算法,我一个不会,太难了吧

程序员垃圾简历长什么样?

已经连续五年参加大厂校招、社招的技术面试工作,简历看的不下于万份 这篇文章会用实例告诉你,什么是差的程序员简历! 疫情快要结束了,各个公司也都开始春招了,作为即将红遍大江南北的新晋UP主,那当然要为小伙伴们做点事(手动狗头)。 就在公众号里公开征简历,义务帮大家看,并一一点评。《启舰:春招在即,义务帮大家看看简历吧》 一石激起千层浪,三天收到两百多封简历。 花光了两个星期的所有空闲时...

立即提问
相关内容推荐